Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90	(revision 3083)
@@ -1,21 +1,21 @@
-! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
+! Copyright 2013-2015,2017,2022 Université de Reims Champagne-Ardenne
 ! Contributor: J. Burgalat (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
-! 
+!
 ! This software is a computer program whose purpose is to compute
 ! microphysics processes using a two-moments scheme.
-! 
+!
 ! This library is governed by the CeCILL-B license under French law and
-! abiding by the rules of distribution of free software.  You can  use, 
+! abiding by the rules of distribution of free software.  You can  use,
 ! modify and/ or redistribute the software under the terms of the CeCILL-B
 ! license as circulated by CEA, CNRS and INRIA at the following URL
-! "http://www.cecill.info". 
-! 
+! "http://www.cecill.info".
+!
 ! As a counterpart to the access to the source code and  rights to copy,
 ! modify and redistribute granted by the license, users are provided only
 ! with a limited warranty  and the software's author,  the holder of the
 ! economic rights,  and the successive licensors  have only  limited
-! liability. 
-! 
+! liability.
+!
 ! In this respect, the user's attention is drawn to the risks associated
 ! with loading,  using,  modifying and/or developing or reproducing the
@@ -25,8 +25,8 @@
 ! professionals having in-depth computer knowledge. Users are therefore
 ! encouraged to load and test the software's suitability as regards their
-! requirements in conditions enabling the security of their systems and/or 
-! data to be ensured and,  more generally, to use and operate it in the 
-! same conditions as regards security. 
-! 
+! requirements in conditions enabling the security of their systems and/or
+! data to be ensured and,  more generally, to use and operate it in the
+! same conditions as regards security.
+!
 ! The fact that you are presently reading this means that you have had
 ! knowledge of the CeCILL-B license and that you accept its terms.
@@ -35,14 +35,14 @@
 !! summary: Parameters and global variables module.
 !! author: J. Burgalat
-!! date: 2013-2015,2017
+!! date: 2013-2015,2017,2022
 
 MODULE MM_GLOBALS
   !! Parameters and global variables module.
-  !!  
+  !!
   !! # Module overview
   !!
   !! The module defines all the parameters and global variables that are common
   !! to all other modules of the library.
-  !! 
+  !!
   !! It is separated in two parts :
   !!
@@ -52,27 +52,27 @@
   !!   method.
   !! - The second part defines a set of vectors that defines the vertical structure of the atmosphere.
-  !!   Each time a new atmospheric column has to be computed (either on a new timestep or on a new couple 
-  !!   of longitude/latitude), these vectors should be intialized with new values by calling 
-  !!   [[mm_globals(module):mm_column_init(function)]] method. 
-  !!   This part is separated in two sets : 
-  !!
-  !!   - The atmospheric structure with temperature, pressure levels and altitude definitions. 
-  !!   - The vertical profiles of tracers with the moments of the two aerosols modes (both \(M_{0}\) 
-  !!     and \(M_{3}\) for a total of 4 vectors), the _clouds_ microphysics moments tracers (i.e. 
+  !!   Each time a new atmospheric column has to be computed (either on a new timestep or on a new couple
+  !!   of longitude/latitude), these vectors should be intialized with new values by calling
+  !!   [[mm_globals(module):mm_column_init(function)]] method.
+  !!   This part is separated in two sets :
+  !!
+  !!   - The atmospheric structure with temperature, pressure levels and altitude definitions.
+  !!   - The vertical profiles of tracers with the moments of the two aerosols modes (both \(M_{0}\)
+  !!     and \(M_{3}\) for a total of 4 vectors), the _clouds_ microphysics moments tracers (i.e.
   !!     \(M_{0}\) and \(M_{3}\) for the ccn and \(M_{3}\) for the ice components).
-  !!     Additionally, the module also stores intermediates variables of interest such as the 
-  !!     characteristic radii of the aerosols modes, the mean drop radius and the drop density, 
+  !!     Additionally, the module also stores intermediates variables of interest such as the
+  !!     characteristic radii of the aerosols modes, the mean drop radius and the drop density,
   !!     the molar fraction of each condensible species (related to ice components) and some
   !!     scalar variables that holds arrays sizes.
   !!
   !! @note
-  !! All the vectors that represent the vertical structure of the atmosphere (altitude, pressure and 
+  !! All the vectors that represent the vertical structure of the atmosphere (altitude, pressure and
   !! temperature...) are oriented from the __TOP__ of the atmosphere to the __GROUND__.
   !!
-  !! @note 
-  !! The module also imports errors module from __FCCP__ library to get definitions of the error object 
+  !! @note
+  !! The module also imports errors module from __SWIFT__ library to get definitions of the error object
   !! everywhere in the library ([[mm_globals(module)]] is always imported, except in [[mm_mprec(module)]]).
   !!
-  !! # Global variables 
+  !! # Global variables
   !!
   !! [[mm_globals(module)]] module contains the declaration of all global/common variable that are shared
@@ -82,6 +82,6 @@
   !! the following sections list all the global variables by category.
   !!
-  !! ## Control flags 
-  !! 
+  !! ## Control flags
+  !!
   !! | Name               | Description
   !! | :----------------- | :-----------------
@@ -93,5 +93,5 @@
   !! | mm_w_clouds_sed    | Enable/Disable clouds microphysics sedimentation
   !! | mm_w_clouds_nucond | Enable/Disable clouds microphysics nucleation/condensation
-  !! | mm_wsed_m0         | Force all aerosols moments to fall at M0 settling velocity 
+  !! | mm_wsed_m0         | Force all aerosols moments to fall at M0 settling velocity
   !! | mm_wsed_m3         | Force all aerosols moments to fall at M3 settling velocity
   !! | mm_no_fiadero_w    | Enable/Disable __Fiadero__ correction
@@ -101,9 +101,9 @@
   !! | Name            | Description
   !! | :-------------- | :-----------------
-  !! | mm_fiadero_min  | Minimum ratio for __Fiadero__'s correction 
+  !! | mm_fiadero_min  | Minimum ratio for __Fiadero__'s correction
   !! | mm_fiadero_max  | Maximum ratio for __Fiadero__'s correction
-  !! | mm_coag_choice  | Coagulation interaction activation flag. It should be a combination of [[mm_globals(module):mm_coag_no(variable)]], [[mm_globals(module):mm_coag_ss(variable)]], [[mm_globals(module):mm_coag_sf(variable)]] and [[mm_globals(module):mm_coag_ff(variable)]]. 
-  !!
-  !! ## Physical constants 
+  !! | mm_coag_choice  | Coagulation interaction activation flag. It should be a combination of [[mm_globals(module):mm_coag_no(variable)]], [[mm_globals(module):mm_coag_ss(variable)]], [[mm_globals(module):mm_coag_sf(variable)]] and [[mm_globals(module):mm_coag_ff(variable)]].
+  !!
+  !! ## Physical constants
   !!
   !! | Name      | Description
@@ -131,5 +131,5 @@
   !! | mm_w_prod   | Angular frequency of the time-dependent production rate.
   !! | mm_ne       | Electric charging of aerosols (\(e^{-}.m^{-1}\)) (unused)
-  !! | mm_rb2ra    | Bulk to apparent radius conversion pre-factor (\(m^X\)) 
+  !! | mm_rb2ra    | Bulk to apparent radius conversion pre-factor (\(m^X\))
   !! | mm_rpla     | Planet radius (m)
   !! | mm_g0       | Planet acceleration due to gravity constant (ground) (\(m.s^{-2}\))
@@ -152,5 +152,5 @@
   ! the following variables are read-only outside this module.
   ! One must call the afferent subroutine to update them.
-    
+
   ! initialization control flags (cannot be updated)
   PROTECTED :: mm_ini,mm_ini_col,mm_ini_aer,mm_ini_cld
@@ -165,7 +165,9 @@
   ! Moments parameters (derived, are updated with moments parameters)
   PROTECTED :: mm_rcs, mm_rcf, mm_drad, mm_drho
-
-  LOGICAL, SAVE :: mm_debug = .true.  !! Enable QnD debug mode (can be used for devel).
-  LOGICAL, SAVE :: mm_log = .false.   !! Enable log mode (for configuration only).
+  ! Thresholds parameters
+  PROTECTED :: mm_m0as_min, mm_m3as_min, mm_rcs_min, mm_m0af_min, mm_m3af_min, mm_rcf_min, mm_m0n_min, mm_m3cld_min
+
+  LOGICAL, SAVE :: mm_debug = .false.  !! Enable QnD debug mode (can be used for devel).
+  LOGICAL, SAVE :: mm_log   = .false.   !! Enable log mode (for configuration only).
 
   LOGICAL, SAVE :: mm_w_haze_prod = .true. !! Enable/Disable haze production.
@@ -182,17 +184,17 @@
   !> Enable/Disable __Fiadero__'s correction.
   !!
-  !! This flag enables/disables the __Fiadero__ correction alogrithm for fractal mode settling velocity 
-  !! computation. 
+  !! This flag enables/disables the __Fiadero__ correction alogrithm for fractal mode settling velocity
+  !! computation.
   !!
   !! @bug
-  !! Currently, the Fiadero correction creates instatibilities on the vertical structure. It seems to be 
+  !! Currently, the Fiadero correction creates instatibilities on the vertical structure. It seems to be
   !! related to the coupling between the two moments. In order to reduce the instabilities, settling
   !! velocity of moments are forced to be the same, see [[mm_globals(module):mm_wsed_m0(variable)]] and
   !! [[mm_globals(module):mm_wsed_m3(variable)]]).
-  LOGICAL, SAVE          :: mm_no_fiadero_w = .false. 
+  LOGICAL, SAVE          :: mm_no_fiadero_w = .false.
 
   !> Minimum ratio for __Fiadero__ correction.
   !!
-  !! When [[mm_globals(module):mm_no_fiadero_w(variable)]] is disabled, this variable defines the minimum 
+  !! When [[mm_globals(module):mm_no_fiadero_w(variable)]] is disabled, this variable defines the minimum
   !! value of the moment's ratio between two adjacents vertical cells to be used within the correction.
   REAL(kind=mm_wp), SAVE :: mm_fiadero_min  = 0.1_mm_wp
@@ -200,5 +202,5 @@
   !> Maximum ratio for __Fiadero__ correction.
   !!
-  !! When [[mm_globals(module):mm_no_fiadero_w(variable)]] is disabled, this variable defines the maximum 
+  !! When [[mm_globals(module):mm_no_fiadero_w(variable)]] is disabled, this variable defines the maximum
   !! value of the moment's ratio between two adjacents vertical cells to be used within the correction.
   REAL(kind=mm_wp), SAVE :: mm_fiadero_max  = 10._mm_wp
@@ -213,10 +215,10 @@
   INTEGER, PARAMETER :: mm_coag_ff = 4 !! FF mode interaction for coagulation.
   !> Default interactions to activate (all by default).
-  INTEGER, SAVE      :: mm_coag_choice = mm_coag_ss+mm_coag_sf+mm_coag_ff 
+  INTEGER, SAVE      :: mm_coag_choice = mm_coag_ss+mm_coag_sf+mm_coag_ff
 
   !> Pi number.
   REAL(kind=mm_wp), PARAMETER :: mm_pi = 4._mm_wp*atan(1._mm_wp)
   !> Avogadro number.
-  REAL(kind=mm_wp), PARAMETER :: mm_navo = 6.0221367e23_mm_wp 
+  REAL(kind=mm_wp), PARAMETER :: mm_navo = 6.0221367e23_mm_wp
   !> Boltzmann constant (\(J.K^{-1}\)).
   REAL(kind=mm_wp), PARAMETER :: mm_kboltz = 1.3806488e-23_mm_wp
@@ -261,16 +263,48 @@
 
   !> Bulk to apparent radius conversion pre-factor (\(m^{X}\)).
-  !! 
-  !! It is initialized using [[mm_globals(module):mm_rm(variable)]] in 
+  !!
+  !! It is initialized using [[mm_globals(module):mm_rm(variable)]] in
   !! [[mm_globals(module):mm_global_init(interface)]] from the following equation:
   !!
   !! $$ r_{a} = r_{b}^{3/D_{f}}\times r_{m}^{\frac{D_{f}-3}{D_{f}}} $$
   !!
-  !! Where \(r_{a}\) is the apparent radius, \(r_{b}\) the bulk radius and 
+  !! Where \(r_{a}\) is the apparent radius, \(r_{b}\) the bulk radius and
   !! \(rb2ra = r_{m}^{\frac{D_{f}-3}{D_{f}}}\) is the returned pre-factor
-  REAL(kind=mm_wp), SAVE :: mm_rb2ra = 1._mm_wp 
+  REAL(kind=mm_wp), SAVE :: mm_rb2ra = 1._mm_wp
+
+  ! Thresholds !
+
+  !> (min.) Total number of aerosols minimum threshold for the spherical mode.
+  REAL(kind=mm_wp), SAVE :: mm_m0as_min = 1.e-10_mm_wp
+
+  !> (min.) Total volume of aerosols minimum threshold for the spherical mode.
+  REAL(kind=mm_wp), SAVE :: mm_m3as_min = 1.e-40_mm_wp
+
+  !> Characteristic radius minimum threshold for the spherical mode.
+  REAL(kind=mm_wp), SAVE :: mm_rcs_min = 1.e-9_mm_wp
+
+  !> (min.) Total number of aerosols minimum threshold for the fractal mode.
+  REAL(kind=mm_wp), SAVE :: mm_m0af_min = 1.e-10_mm_wp
+
+  !> (min.) Total volume of aerosols minimum threshold for the fractal mode.
+  REAL(kind=mm_wp), SAVE :: mm_m3af_min = 1.e-40_mm_wp
+
+  !> Characteristic radius minimum threshold for the fractal mode.
+  REAL(kind=mm_wp), SAVE :: mm_rcf_min = 1.e-9_mm_wp
+
+  !> (min.) Total number of cloud drop minimum threshold.
+  REAL(kind=mm_wp), SAVE :: mm_m0n_min = 1.e-10_mm_wp
+
+  !> (min.) Total volume of cloud drop minimum threshold.
+  REAL(kind=mm_wp), SAVE :: mm_m3cld_min = 1.e-40_mm_wp
 
   !> Characteristic radius threshold.
   REAL(kind=mm_wp), SAVE :: mm_rc_min = 1.e-200_mm_wp
+
+  !> Minimum cloud drop radius
+  REAL(kind=mm_wp), SAVE :: mm_drad_min = 1.e-9_mm_wp
+
+  !> Maximum cloud drop radius
+  REAL(kind=mm_wp), SAVE :: mm_drad_max = 1.e-3_mm_wp
 
   !> Name of condensible species.
@@ -339,11 +373,11 @@
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_temp
   !>  Air density vertical profile (\(kg.m^{-3}\)).
-  REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_rhoair 
+  REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_rhoair
   !> Temperature vertical profil at interfaces (K).
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_btemp
 
   !> Atmospheric levels thickness (m).
-  !! 
-  !! Atmospheric thickness between two adjacent levels (\(m\)) from the 
+  !!
+  !! Atmospheric thickness between two adjacent levels (\(m\)) from the
   !! __TOP__ to the __GROUND__.
   !! @note __mm_dzlev__ is defined on the total number of layers and actually
@@ -352,11 +386,11 @@
 
   !> Atmospheric layers "thickness" (m).
-  !! 
+  !!
   !! Atmospheric thickness between the center of two adjacent layers (\(m\))
   !! from the __TOP__ to the __GROUND__.
-  !! @note 
-  !! __mm_dzlay__ is defined on the total number of layers. The last 
+  !! @note
+  !! __mm_dzlay__ is defined on the total number of layers. The last
   !! value of __mm_dzlay__ is set to twice the altitude of the ground layer.
-  !! @note This value corresponds to the thickness between the center of the 
+  !! @note This value corresponds to the thickness between the center of the
   !! __GROUND__ layer and below the surface. It is arbitrary and not used.
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_dzlay
@@ -377,7 +411,7 @@
   !> Ice components 3rd order moments (\(m^{3}.m^{-3}\)).
   !!
-  !! It is a 2D array with the vertical layers in first dimension, and the number of ice 
+  !! It is a 2D array with the vertical layers in first dimension, and the number of ice
   !! components in the second.
-  !! @note 
+  !! @note
   !! Both [[mm_globals(module):mm_m3ice(variable)]] and [[mm_globals(module):mm_gazs(variable)]]
   !! share the same indexing (related to species order).
@@ -387,6 +421,6 @@
   !!
   !! It is a 2D array with the vertical layers in first dimension, and
-  !! the number of condensible species in the second. 
-  !! @note 
+  !! the number of condensible species in the second.
+  !! @note
   !! Both [[mm_globals(module):mm_m3ice(variable)]] and [[mm_globals(module):mm_gazs(variable)]]
   !! share the same indexing (related to species order).
@@ -410,8 +444,8 @@
   !> Spherical mode \(M_{0}\) settling velocity (\(m.s^{-1}\)).
   !!
-  !! It is a vector with the vertical layers that contains the settling velocity for 
+  !! It is a vector with the vertical layers that contains the settling velocity for
   !! the \(0^{th}\) order moment of the spherical mode.
   !! It is updated in [[mm_haze(module):mm_haze_sedimentation(subroutine)]].
-  !! @note 
+  !! @note
   !! This variable is always negative.
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_m0as_vsed
@@ -419,8 +453,8 @@
   !> Spherical mode \(M_{3}\) settling velocity (\(m.s^{-1}\)).
   !!
-  !! It is a vector with the vertical layers that contains the settling velocity for the 
+  !! It is a vector with the vertical layers that contains the settling velocity for the
   !! \(3^{rd}\) order moment of the spherical mode.
   !! It is updated in [[mm_haze(module):mm_haze_sedimentation(subroutine)]].
-  !! @note 
+  !! @note
   !! This variable is always negative.
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_m3as_vsed
@@ -428,8 +462,8 @@
   !> Fractal mode \(M_{0}\) settling velocity (\(m.s^{-1}\)).
   !!
-  !! It is a vector with the vertical layers that contains the settling velocity for the 
+  !! It is a vector with the vertical layers that contains the settling velocity for the
   !! \(0^{th}\) order moment of the fractal mode.
   !! It is updated in [[mm_haze(module):mm_haze_sedimentation(subroutine)]].
-  !! @note 
+  !! @note
   !! This variable is always negative.
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_m0af_vsed
@@ -437,8 +471,8 @@
   !> Fractal mode \(M_{3}\) settling velocity (\(m.s^{-1}\)).
   !!
-  !! It is a vector with the vertical layers that contains the settling velocity for the 
+  !! It is a vector with the vertical layers that contains the settling velocity for the
   !! \(3^{rd}\) order moment of the fractal mode.
   !! It is updated in [[mm_haze(module):mm_haze_sedimentation(subroutine)]].
-  !! @note 
+  !! @note
   !! This variable is always negative.
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_m3af_vsed
@@ -448,5 +482,5 @@
   !! It is a vector with the vertical layers that contains the mass fluxes for spherical aerosols.
   !! It is updated in [[mm_haze(module):mm_haze_sedimentation(subroutine)]].
-  !! @note 
+  !! @note
   !! This variable is always negative.
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_aer_s_flux
@@ -456,5 +490,5 @@
   !! It is a vector with the vertical layers that contains the mass fluxes for fractal aerosols
   !! It is updated in [[mm_haze(module):mm_haze_sedimentation(subroutine)]].
-  !! @note 
+  !! @note
   !! This variable is always negative.
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_aer_f_flux
@@ -464,16 +498,25 @@
   REAL(kind=mm_wp), SAVE :: mm_ccn_prec = 0._mm_wp
 
-  !> CCN mass fluxes (\(kg.m^{-2}.s^{-1}\)).
-  !!
-  !! It is a vector with the vertical layers that contains the 
-  !! mass fluxes for CCN. 
+  !> CCN settling velocity (\(m.s^{-1}\)).
+  !!
+  !! It is a vector with the vertical layers that contains the
+  !! settling velocity for CCN (and ices).
   !! It is updated in [[mm_clouds(module):mm_cloud_microphysics(subroutine)]].
   !! @note
-  !! This variable is always negative.
+  !! This variable is always positive.
+  REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_ccn_w
+  
+  !> CCN mass fluxes (\(kg.m^{-2}.s^{-1}\)).
+  !!
+  !! It is a vector with the vertical layers that contains the
+  !! mass fluxes for CCN.
+  !! It is updated in [[mm_clouds(module):mm_cloud_microphysics(subroutine)]].
+  !! @note
+  !! This variable is always positive.
   REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE, SAVE :: mm_ccn_flux
 
   !> Ice components precipitations (m).
   !!
-  !! It is a vector of [[mm_globals(module):mm_nesp(variable)]] values which share the same indexing 
+  !! It is a vector of [[mm_globals(module):mm_nesp(variable)]] values which share the same indexing
   !! than [[mm_globals(module):mm_m3ice(variable)]] and [[mm_globals(module):mm_gazs(variable)]].
   !! It is updated in [[mm_clouds(module):mm_cloud_microphysics(subroutine)]].
@@ -484,5 +527,5 @@
   !> Ice components sedimentation fluxes (\(kg.m^{-2}.s-1\)).
   !!
-  !! It is a 2D-array with the vertical layers in first dimension and the number of ice components 
+  !! It is a 2D-array with the vertical layers in first dimension and the number of ice components
   !! in the second. It is updated in [[mm_clouds(module):mm_cloud_microphysics(subroutine)]].
   !! @note
@@ -492,5 +535,5 @@
   !> Condensible species saturation ratio (--).
   !!
-  !! It is a 2D-array with the vertical layers in first dimension and the number of condensible 
+  !! It is a 2D-array with the vertical layers in first dimension and the number of condensible
   !! species in the second.
   !! It is updated in [[mm_clouds(module):mm_cloud_microphysics(subroutine)]].
@@ -516,5 +559,5 @@
   INTERFACE mm_cloud_properties
     MODULE PROCEDURE cldprop_sc,cldprop_ve
-  END INTERFACE
+  END INTERFACE mm_cloud_properties
 
   !> Interface to global initialization.
@@ -522,14 +565,13 @@
   !! The method performs the global initialization of the model.
   !! @warning
-  !! If OpenMP is activated, this subroutine must be called in an $OMP SINGLE statement as it 
+  !! If OpenMP is activated, this subroutine must be called in an $OMP SINGLE statement as it
   !! initializes global variable that are not thread private.
   !!
-  !! '''
-  !! !$OMP SINGLE
-  !! call mm_global_init(...)
-  !! !$OMP END SINGLE
+  !!   !$OMP SINGLE
+  !!   call mm_global_init(...)
+  !!   !$OMP END SINGLE
   INTERFACE mm_global_init
     MODULE PROCEDURE mm_global_init_0,mm_global_init_1
-  END INTERFACE
+  END INTERFACE mm_global_init
 
   !> Check an option from the configuration system.
@@ -538,11 +580,11 @@
   !! set a default value if the option is not found. This is an overloaded method
   !! that can take in input either a floating point, integer, logical or string
-  !! option value. 
+  !! option value.
   INTERFACE mm_check_opt
     MODULE PROCEDURE check_r1,check_i1,check_l1,check_s1
-  END INTERFACE
+  END INTERFACE mm_check_opt
 
   ! --- OPENMP ---------------
-  ! All variable related to column computations should be private to each thread
+  ! All variables related to column computations should be private to each thread
   !
   !$OMP THREADPRIVATE(mm_ini_col,mm_ini_aer,mm_ini_cld)
@@ -551,7 +593,7 @@
   !$OMP THREADPRIVATE(mm_m0ccn,mm_m3ccn,mm_m3ice,mm_gazs)
   !$OMP THREADPRIVATE(mm_rcs,mm_rcf,mm_drad,mm_drho)
-  !$OMP THREADPRIVATE(mm_aer_s_flux,mm_aer_f_flux,mm_ccn_flux,mm_ice_prec,mm_ice_fluxes,mm_gazs_sat)
+  !$OMP THREADPRIVATE(mm_aer_s_flux,mm_aer_f_flux,mm_ccn_w,mm_ccn_flux,mm_ice_prec,mm_ice_fluxes,mm_gazs_sat)
   !$OMP THREADPRIVATE(mm_m0as_vsed,mm_m3as_vsed,mm_m0af_vsed,mm_m3af_vsed)
-
+  !$OMP THREADPRIVATE(mm_m0as_min,mm_m3as_min,mm_rcs_min,mm_m0af_min,mm_m3af_min,mm_rcf_min,mm_m0n_min,mm_m3cld_min)
   !$OMP THREADPRIVATE(mm_nla,mm_nle)
 
@@ -559,88 +601,97 @@
 
 
-  CONTAINS 
+CONTAINS
 
   FUNCTION mm_global_init_0(dt,df,rm,rho_aer,p_prod,tx_prod,rc_prod,rplanet,g0, &
-                            air_rad,air_mmol,coag_interactions,clouds,spcfile,  &
-                            w_haze_prod,w_haze_sed,w_haze_coag,w_cloud_nucond,  &
-                            w_cloud_sed,force_wsed_to_m0,force_wsed_to_m3,      &
-                            no_fiadero,fiadero_min,fiadero_max) RESULT(err)
+    air_rad,air_mmol,coag_interactions,clouds,spcfile,  &
+    w_haze_prod,w_haze_sed,w_haze_coag,w_cloud_nucond,  &
+    w_cloud_sed,force_wsed_to_m0,force_wsed_to_m3,      &
+    no_fiadero,fiadero_min,fiadero_max,                 &
+    m0as_min,rcs_min,m0af_min,rcf_min,m0n_min,debug) RESULT(err)
     !! Initialize global parameters of the model.
-    !! 
+    !!
     !! The function initializes all the global parameters of the model from direct input.
-    !! Boolean (and Fiadero) parameters are optional as they are rather testing parameters. Their 
-    !! default values are suitable for production runs.  
+    !! Boolean, Fiadero and thresholds parameters are optional as they are rather testing parameters.
+    !! Their default values are suitable for production runs.
     !! @note
     !! If the method fails to initialize parameters (i.e. returned error is not 0). Then the model
     !! should probably be aborted as the global variables of the model will not be correctly setup.
     !! @warning
-    !! If OpenMP is activated, this subroutine must be called in an $OMP SINGLE statement as it 
-    !! initializes global variable that are not thread private.
-    !!
-    !! '''
-    !! !$OMP SINGLE
-    !! call mm_global_init_0(...)
-    !! !$OMP END SINGLE
+    !! If OpenMP is activated, this subroutine must be called in an $OMP SINGLE statement as it
+    !! initializes (only) global variables that are not thread private.
+    !!
+    !!   !$OMP SINGLE
+    !!   call mm_global_init_0(...)
+    !!   !$OMP END SINGLE
     REAL(kind=mm_wp), INTENT(in)           :: dt
-      !! Microphysics timestep in seconds.
+    !! Microphysics timestep in seconds.
     REAL(kind=mm_wp), INTENT(in)           :: df
-      !! Fractal dimension of fractal aerosol.
+    !! Fractal dimension of fractal aerosol.
     REAL(kind=mm_wp), INTENT(in)           :: rm
-      !! Monomer radius in meter.
+    !! Monomer radius in meter.
     REAL(kind=mm_wp), INTENT(in)           :: rho_aer
-      !! Aerosol density in \(kg.m^{-3}\).
+    !! Aerosol density in \(kg.m^{-3}\).
     REAL(kind=mm_wp), INTENT(in)           :: p_prod
-      !!  Aerosol production pressure level in Pa.
+    !!  Aerosol production pressure level in Pa.
     REAL(kind=mm_wp), INTENT(in)           :: tx_prod
-      !! Spherical aerosol mode production rate in \(kg.m^{-2}.s^{-1}\).
+    !! Spherical aerosol mode production rate in \(kg.m^{-2}.s^{-1}\).
     REAL(kind=mm_wp), INTENT(in)           :: rc_prod
-      !! Spherical mode characteristic radius for production in meter.
+    !! Spherical mode characteristic radius for production in meter.
     REAL(kind=mm_wp), INTENT(in)           :: rplanet
-      !! Planet radius in meter
+    !! Planet radius in meter
     REAL(kind=mm_wp), INTENT(in)           :: g0
-      !! Planet gravity acceleration at ground level in \(m.s^{-2}\).
+    !! Planet gravity acceleration at ground level in \(m.s^{-2}\).
     REAL(kind=mm_wp), INTENT(in)           :: air_rad
-      !! Air molecules mean radius in meter.
+    !! Air molecules mean radius in meter.
     REAL(kind=mm_wp), INTENT(in)           :: air_mmol
-      !! Air molecules mean molar mass in \(kg.mol^{-1}\).
+    !! Air molecules mean molar mass in \(kg.mol^{-1}\).
     INTEGER, INTENT(in)                    :: coag_interactions
-      !! Coagulation interactions process control flag.
+    !! Coagulation interactions process control flag.
     LOGICAL, INTENT(in)                    :: clouds
-      !! Clouds microphysics control flag.
+    !! Clouds microphysics control flag.
     CHARACTER(len=*), INTENT(in)           :: spcfile
-      !! Clouds microphysics condensible species properties file.
+    !! Clouds microphysics condensible species properties file.
     REAL(kind=mm_wp), INTENT(in), OPTIONAL :: fiadero_max
-      !! Maximum moment ratio threshold for Fiadero correction (default: 10.) .
+    !! Maximum moment ratio threshold for Fiadero correction (default: 10.) .
     REAL(kind=mm_wp), INTENT(in), OPTIONAL :: fiadero_min
-      !! Minimum moment ratio threshold for Fiadero correction (default: 0.1).
+    !! Minimum moment ratio threshold for Fiadero correction (default: 0.1).
     LOGICAL, INTENT(in), OPTIONAL          :: w_haze_prod
-      !! Haze microphysics production process control flag (default: T).
+    !! Haze microphysics production process control flag (default: T).
     LOGICAL, INTENT(in), OPTIONAL          :: w_haze_sed
-      !! Haze microphysics sedimentation process control flag (default: T).
+    !! Haze microphysics sedimentation process control flag (default: T).
     LOGICAL, INTENT(in), OPTIONAL          :: w_haze_coag
-      !! Haze microphysics coagulation process control flag (default: T).
+    !! Haze microphysics coagulation process control flag (default: T).
     LOGICAL, INTENT(in), OPTIONAL          :: w_cloud_sed
-      !! Cloud microphysics nucleation/conensation process control flag (default: __clouds__ value).
+    !! Cloud microphysics nucleation/conensation process control flag (default: __clouds__ value).
     LOGICAL, INTENT(in), OPTIONAL          :: w_cloud_nucond
-      !! Cloud microphysics production process control flag (default: __clouds__ value).
+    !! Cloud microphysics production process control flag (default: __clouds__ value).
     LOGICAL, INTENT(in), OPTIONAL          :: no_fiadero
-      !! Disable Fiadero correction for haze sedimentation process (default: F).
+    !! Disable Fiadero correction for haze sedimentation process (default: F).
     LOGICAL, INTENT(in), OPTIONAL          :: force_wsed_to_m0
-      !! force __all__ aerosols moments to fall at M0 settling velocity (default: T).
-    LOGICAL, INTENT(in), OPTIONAL          :: force_wsed_to_m3 
-      !! Force __all__ aerosols moments to fall at M3 settling velocity (default: F).
+    !! force __all__ aerosols moments to fall at M0 settling velocity (default: T).
+    LOGICAL, INTENT(in), OPTIONAL          :: force_wsed_to_m3
+    !! Force __all__ aerosols moments to fall at M3 settling velocity (default: F).
+    REAL(kind=mm_wp), INTENT(in), OPTIONAL :: m0as_min
+    !! Minimum threshold for M0 of the spherical mode (default: 1e-10).
+    REAL(kind=mm_wp), INTENT(in), OPTIONAL :: rcs_min
+    !! Minimum threshold for the characteristic radius of the spherical mode in meter (default: 1e-9).
+    REAL(kind=mm_wp), INTENT(in), OPTIONAL :: m0af_min
+    !! Minimum threshold for M0 of the factal mode (default: 1e-10).
+    REAL(kind=mm_wp), INTENT(in), OPTIONAL :: rcf_min
+    !! Minimum threshold for the characteristic radius of the fractal mode in meter (default: _monomer radius_).
+    REAL(kind=mm_wp), INTENT(in), OPTIONAL :: m0n_min
+    !! Minimum threshold for M0 of cloud drop (default: 1e-10).
+    LOGICAL, INTENT(in), OPTIONAL          :: debug
+    !! Debug mode control flag (may print lot of stuff if enabled)
     TYPE(error) :: err
-      !! Error status of the function.
+    !! Error status of the function.
     INTEGER                                           :: i
     TYPE(cfgparser)                                   :: cp
-    CHARACTER(len=st_slen)                            :: spcpath
-    CHARACTER(len=:), ALLOCATABLE                     :: defmsg
     CHARACTER(len=st_slen), DIMENSION(:), ALLOCATABLE :: species
     REAL(kind=mm_wp)                                  :: zfiamin,zfiamax
     LOGICAL                                           :: zwhp,zwhs,zwhc,zwcs,zwcn,znofia, &
                                                          zwstom0,zwstom3
-
     zwhp = .true. ; zwhs = .true. ; zwhc = .true.
-    zwcs = clouds ; zwcn = clouds 
+    zwcs = clouds ; zwcn = clouds
     znofia = .false. ; zfiamin = 0.1_mm_wp ; zfiamax = 10._mm_wp
     zwstom0 = .true. ; zwstom3 = .false.
@@ -652,8 +703,8 @@
 
     ! Store options values in global variables...
-    mm_df          = df 
-    mm_rm          = rm 
+    mm_df          = df
+    mm_rm          = rm
     mm_rb2ra       = mm_rm**((mm_df-3._mm_wp)/mm_df) ! conversion factor for bulk -> fractal radius
-    mm_rhoaer      = rho_aer 
+    mm_rhoaer      = rho_aer
     mm_p_prod      = p_prod
     mm_tx_prod     = tx_prod
@@ -662,5 +713,5 @@
     mm_g0          = g0
     mm_dt          = dt
-    mm_air_rad     = mm_air_rad
+    mm_air_rad     = air_rad
     mm_air_mmol    = air_mmol
     mm_coag_choice = coag_interactions
@@ -670,4 +721,7 @@
       RETURN
     ENDIF
+
+    ! force fractal radius minimum threshold to monomer radius ^^
+    mm_rcf_min = mm_rm
 
     mm_w_clouds = clouds
